#!/usr/bin/perl
#
# These set of functions are for parsing port and hosts lists nmap style.
#
##




###############################################################################
#
#   Function:   shuffle
#   Purpose:    Randomize an array
#   To-Do:      Done
#
#   Date: 04/09/99
#
###############################################################################


sub shuffle {
    my $array = shift;
    my $i = scalar(@$array);
    my $j;
    foreach $item (@$array )
    {
        --$i;
        $j = int rand ($i+1);
        next if $i == $j;
        @$array [$i,$j] = @$array[$j,$i];
    }
    return @$array;
}



###############################################################################
#
#   Function:   parse_ports
#   Purpose:    Take in an nmap style port list and return an array
#   To-Do:      Add a check to make sure all the ports added are numeric
#
#   Date: 04/09/99
#
###############################################################################

sub parse_ports {
    my ($portstring) = @_;
    my $splitter = ",";
    my @portlist = ();
    my @portsplit = ();
    my $port;
   
    @portsplit = split($splitter,$portstring);
    foreach $port (@portsplit)
   
    {
        @range = split(/\-/,$port);
        if (scalar(@range) > 1)
        {
            if ($range[0] > $range[1] || $range[0] < 0 || $range[0] > 65535 || $range[1] < 0 || $range[1] > 65535)
            {
                print "Your range of $range[0] -> $range[1] is invalid!\n";
                exit(1);
            }
            for ($i = $range[0]; $i < $range[1] + 1; $i++)
            {
                if ($i > 0 && $i < 65536)
                {
                    push @portlist, $i;   
                }
            }
        
        } else {
            push @portlist, $port;
        }
    }
    
    return @portlist;
}



# so perl doesnt bitch
return 1;
